%
% Solve system of diffusion ODE
% Featural signals (COCE.Feature) are gated by Boundary signals
% COCE.Boundary
% The system of ODE is solved at equilibrium
% Output is placed in COCE.Percept
%

e=100; %diffusion coefficien
sigma = 100000;% diffusion coefficient
M=5; % decay parameter

S=zeros(COCE.PopulationSize(2));
PL(1:COCE.PopulationSize(2))=0;
PR(1:COCE.PopulationSize(2))=0;

for i=2:COCE.PopulationSize(2)-1
    PR(i) = sigma/((1+e*(COCE.Boundary(i)+COCE.Boundary(i+1))));
    PL(i) = sigma/((1+e*(COCE.Boundary(i)+COCE.Boundary(i-1))));
end
PR(1)= sigma/((1+e*(COCE.Boundary(1)+COCE.Boundary(2))));
PL(1) = sigma/((1+e*COCE.Boundary(1)));
PR(end)= sigma/((1+e*COCE.Boundary(end)));
PL(end) = sigma/((1+e*(COCE.Boundary(end)+COCE.Boundary(end-1))));
for i=2:COCE.PopulationSize(2)-1
    S(i,i-1) = S(i,i-1) - PR(i-1);
    S(i,i+1) = S(i,i+1) - PL(i+1);
    S(i,i)=M+PR(i-1)+PL(i+1);
end
S(1,1) =  M+PL(i+1);
S(end,end) =  M+PR(i-1);
S(end,end-1) = S(end,end-1) - PR(end-1);
S(1,2) = S(1,2) - PL(2);
COCE.Percept = S\COCE.Feature';
